Summary: Cluster administation tools  
Name: piranha
Version: 0.4.16
Release: 4
Copyright: GPL 
Packager: P.Copeland <copeland@redhat.com>
Group: System Environment/Base 
Source0: piranha-%{PACKAGE_VERSION}.tar.gz
Buildroot: %{_tmppath}/piranha-root
Prereq: /sbin/chkconfig 
Requires: kernel >= 2.2.16-2
Requires: ipvsadm >= 1.11-2
Obsoletes: ipvsadm-1.1-2


%package gui
Requires: piranha 
Summary: The cute little graphical configuration tool for lvs
Group: Applications/System
Requires: popt apache php

%package docs
Summary: Documentation for the Red Hat clustering environment
Group: Documentation

%description 
Various tools to administer and configure the Linux Virtual Server as well as
heartbeating and failover components.  The LVS is a dynamically adjusted
kernel routing mechanism that provides load balancing for web servers and ftp
servers.  

%description docs
This package contains documentation files found on the Internet as well as
some written by Red Hat.  These files include the HTML contents of
www.linuxvirtualserver.org.

%description gui
Piranha is a GUI frontend tool to administer the cluster nodes.  It calls
the lvs backend daemon to manage and edit the lvs configuration file.

%prep
%setup -n piranha -q
mv docs/HOWTO.lvs HOWTO.lvs

%build
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" all

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
make install
strip $RPM_BUILD_ROOT/usr/sbin/send_arp 
strip $RPM_BUILD_ROOT/usr/sbin/fos
strip $RPM_BUILD_ROOT/usr/sbin/lvs
strip $RPM_BUILD_ROOT/usr/sbin/nanny
strip $RPM_BUILD_ROOT/usr/sbin/pulse

mkdir -p $RPM_BUILD_ROOT/home/httpd/html/piranha
cp -Rfv web/* $RPM_BUILD_ROOT/home/httpd/html/piranha
echo /home/httpd/html/piranha > HTMLFILES

mkdir -p $RPM_BUILD_ROOT/etc
touch $RPM_BUILD_ROOT/etc/piranha.passwd
chmod 600 $RPM_BUILD_ROOT/etc/piranha.passwd
chown root.root $RPM_BUILD_ROOT/etc/piranha.passwd

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%pre
/usr/sbin/groupadd -g 60 -r -f piranha > /dev/null 2>&1 ||:
/usr/sbin/useradd -u 60 -g 60 -d /home/httpd/html/piranha -r -s \
	/dev/null piranha > /dev/null 2>&1 ||:

touch /etc/lvs.cf
chmod 664 /etc/lvs.cf
chown piranha.nobody /etc/lvs.cf

%pre gui
if [ `grep -c html/piranha /etc/httpd/conf/httpd.conf` = 0 ]; then
       echo "<Directory /home/httpd/html/piranha>" >> /etc/httpd/conf/httpd.conf
       echo "  Options All" >> /etc/httpd/conf/httpd.conf
       echo "  AllowOverride All" >> /etc/httpd/conf/httpd.conf
       echo "</Directory>" >> /etc/httpd/conf/httpd.conf
fi

%preun
if [ $1 = 0 ]; then
	/sbin/chkconfig --del pulse
fi

%post 
/sbin/chkconfig --add pulse


%postun
if [ $1 = 0 ] ; then
        userdel piranha
fi

%files
%defattr(-,root,root)
%doc sample.cf AUTHORS COPYING Changelog README
%config /etc/rc.d/init.d/pulse
/usr/sbin/lvs
/usr/sbin/fos
/usr/sbin/nanny
/usr/sbin/pulse
/usr/sbin/send_arp
/usr/man/man5/lvs.cf.5*
/usr/man/man8/*

%files docs
%defattr(-,root,root)
%doc docs/*
%doc sample.cf AUTHORS COPYING Changelog README HOWTO.lvs

%files gui -f HTMLFILES
%defattr(-,root,root)
%defattr(-,root,root)
%config /etc/X11/applnk/System/piranha.desktop
%config(noreplace) /etc/piranha.passwd
/usr/sbin/piranha-passwd
/usr/share/gnome/apps/System/piranha.desktop
/usr/share/pixmaps/piranha-icon.png


%changelog
* Wed Sep 13 2000 Philip Copeland <copeland@redhat.com>
- Fixed the 0.4.x/0.5.x html cross contamination 8/

* Tue Jul 26 2000 Philip Copeland <copeland@redhat.com>
- Fixed the missing lvs.ps error when making rpms

* Thu Jul 20 2000 Keith Barrett <kbarrett@redhat.com>
- Fixed udp logic in nanny. Added udp and debug passing to lvs, fos.
- Added --version

* Tue Jun 20 2000 Philip Copeland <copeland@redhat.com>
- Added in Wensongs LVS documentation
- checked that the documentation rpm installs and
  uninstalls cleanly

* Mon Jun 19 2000 Philip Copeland <copeland@redhat.com>
- bounced the release number up
- made sure that piranha will uninstall and reinstall cleanly
  (though docs needs tidying up)
- Made sure that ipvsadm and piranha obsoleted previous versions of
  each other.

* Mon Jun 19 2000 Philip Copeland <copeland@redhat.com>
- Removed ipvsadm from piranha
- piranha now requires ipvsadm-1.11
- tidyups

* Thu Jun 15 2000 Philip Copeland <copeland@redhat.com>
- change the default uptime method to be rup instead of ruptime

* Wed Jun 14 2000 Philip Copeland <copeland@redhat.com>
- reintegrated Keiths changes, tweaked the Makefile,
  updated the comments etc.

* Wed Jun 14 2000 Keith Barrett <kbarrett@redhat.com>
- Backed out some patches to pulse.c, fos.c, lvs.c, and nanny.c
- Updated documentation
- Changed "take control" heartbeat

* Tue Jun 6 2000 Philip Copeland <copeland@redhat.com>
- removed the 'accept' input button in control.php3 to
  better fit the documentation
- Updated the lvserror.php3 to reflect another not so uncommon
  fault that may prevent correct running of the GUI
- Tidied up some eyecandy

* Mon May 31 2000 Philip Copeland <copeland@redhat.com>
- Fixed an incorrect pag redirection in the failover pages
- added two missing subnet masks to the peristance netmask field

* Mon May 22 2000 Philip Copeland <copeland@redhat.com>
- modified the piranha.spec.in file and Makefile to allow for
  release number updates (from editing the Makefile)
- fixed a bug in redundancy.php3 which occurs when no lvs.cf file
  is present
- made ipvsadm popt change (minor patch which shouldn't affect
  native redhat installed systems)

* Sun May 22 2000 Philip Copeland <copeland@redhat.com>
- core item ipvsadm has been updated to use ipvs-0.9.12-2.2.14
- Minor tweeking of directory scruture
- gui files no longer included in rpm builds
- added a load of patches from the bugzilla archives
- made kernel diffs
- made sure the rpms built and installed correctly

* Wed Apr 26 2000 Mike Wangsmo <wanger@redhat.com>
- changed the password updating/setting policy.  Made all password actions
  root operations via a root owned shell tool (piranha-passwd)

* Sun Apr 23 2000 Philip Copeland <copeland@redhat.com>
- Security exposure raised by ISS regarding the passwd.php3
  file fixed by replacing the external call to htpasswd with
  php3s own crypt function (see parse.php3 change_password)
- Rebuilt packages and generated errata.

* Tue Mar 07 2000 Mike Wangsmo <wanger@redhat.com>
- removed killapache
- changed sample httpd shutdown to use proper init scripts
- Keith fixed MORONIC spelling error in pulse.c :)
- moved the GUI README into the %doc list

* Tue Mar 07 2000 Keith Barrett <kbarrett@redhat.com>
- Improved take control heartbeat login in pulse
- Enhanced old GUI README to notify user of special conditions
- Bumped version

* Mon Mar 06 2000 Keith Barrett <kbarrett@redhat.com>
- Bumped version to reflect changes to fos, pulse, and old GUI

* Sun Mar 05 2000 Mike Wangsmo <wanger@redhat.com>
- added fos to file list
- moved apache & php requires to gui package
- reordered the install of killapache to make strip not puke

* Sat Mar  5 2000 Keith Barrett <kbarrett@redhat.com>
- Corrected signaling, heartbeat, and failover in pulse
- Bumped version to reflect a stable release
- Note: pulse USR1/2 disabled in this checkin

* Thu Mar  4 2000 Keith Barrett <kbarrett@redhat.com>
- Corrected memory errors in parser
- Updated fos
- Improved (but have not finished) pulse changes
- Bumped version to reflect parser change

* Wed Mar  2 2000 Philip Copeland <copeland@redhat.com>
- Added password services to web control
- Altered pulse to provide a signal escalator between nobody/root
  as we now have a "use a uid/gid < 100" limitation that
  apache's suexec doesn't cater for
- Added default password to web (null)
- minor spec file changes

* Thu Mar  2 2000 Keith Barrett <kbarrett@redhat.com>
- New version of pulse with enhanced signals
- New service = xxx parameter in config system
- New man pages and doc updates

* Wed Mar  1 2000 Keith Barrett <kbarrett@redhat.com>
- Checked in failover service changes. Not fully
- functional yet.

* Wed Mar  1 2000 Bill Nottingham <notting@redhat.com>
- use a uid/gid < 100

* Mon Feb 28 2000 Mike Wangsmo <wanger@redhat.com>
- fiddled with the /etc/lvs.cf stuff some more

* Fri Feb 25 2000 Mike Wangsmo <wanger@redhat.com>
- *NO* "echo's" in spec files!
- made /etc/lvs.cf a %config so it'll get backed up on upgrades
- cleaned up some useradd/groupadd errors

* Fri Feb 25 2000 Keith Barrett <kbarrett@redhat.com>
- Fixed parsing of protocol = xxx
- Bumped version (again)

* Tue Feb 22 2000 Keith Barrett <kbarrett@redhat.com>
- Fixed passthrough of routing type options
- Fixed man pages to reflect routing type options
- Changed formatting of sample.cf file and included comments
- Bumped version number

* Mon Feb 21 2000 Keith Barrett <kbarrett@redhat.com>
- Fixed segfault problem in nanny
- Minor changes reporting the phase out of the old GUI
- Bumped version number
- Changed spec file to include web in GUI RPM

* Fri Feb 18 2000 Keith Barrett <kbarrett@redhat.com>
- Bumped version to reflect Bryce's changes to install scripts
- Added persistent netmask to lvsconfig and lvs and sample.cf

* Thu Feb 17 2000  Keith Barrett <kbarrett@redhat.com>
- Bumped version
- Improved send/expect stuff

* Wed Feb 16 2000  Keith Barrett <kbarrett@redhat.com>
- Bumped version to reflect GUI changes

* Tue Feb 15 2000 Keith Barrett <kbarrett@redhat.com>
- Added send/expect parsing to lvs, lvsconfig, and nanny.
- Updated nanny man page and sample.cf file

* Tue Feb 15 2000 Mike Wangsmo <wanger@redhat.com>
- added a groupadd line so useradd wouldn't fail.

* Mon Feb 14 2000 Keith Barrett <kbarrett@redhat.com>
- added generic service parameters to nanny.c and nanny.8

* Fri Feb 11 2000 Mike Wangsmo <wanger@redhat.com>
- added uid/gid piranha to setup (233)
- cleaned up %install a bit

* Mon Feb 09 2000 Philip Copeland <copeland@redhat.com>
- Added NAT/direct routing/tunneling to the web interface
- fixed up the web documents to tell the web browsers that
  caching them would be a BAD idea
- Added some prettify stuff

* Mon Feb 07 2000 Keith Barrett <kbarrett@redhat.com>
- Changed pulse call to send_arp to /usr/sbin
- Suppress sock error on unconfigured tunl device
- Bumped version

* Sat Feb 05 2000 Mike Wangsmo <wanger@redhat.com>
- removed piranha-web package and put it into main package

* Fri Feb 04 2000 Keith Barrett <kbarrett@redhat.com>
- Added Bryce's README.beta to beta release

* Thu Feb 03 2000 Nalin Dahyabhai <nalin@redhat.com>
- check that RPM_BUILD_ROOT != / when installing
- handle case if httpd not installed during %install
- handle gzipped man pages

* Thu Feb 03 2000 Mike Wangsmo <wanger@redhat.com>
- tagged the desktop entry as %config

* Thu Jan 27 2000 Keith Barrett <kbarrett@redhat.com>
- Minor updates to doc files and man pages.
- Added headers and history to some source files
- Created nanny.h file

* Sat Sep 25 1999 Mike Wangsmo <wanger@redhat.com>
- added the HOWTO

* Fri Sep 24 1999 Mike Wangsmo <wanger@redhat.com>
- added KDE desktop entry
- added piranha icon pixmap
- fixed *tons* of lvs <-> gui glue problems

* Tue Sep 21 1999 Mike Wangsmo <wanger@redhat.com>
- added a send_arp tool to the package
- removed the /etc/lvs.cf entry (it was dumb here)
- strip all binaries too
- added nanny to package

* Tue Sep 21 1999 Mike Wangsmo <wanger@redhat.com>
- moved all bins to /usr/sbin
- added pulse init script

* Mon Sep 20 1999 Mike Wangsmo <wanger@redhat.com>
- moved piranha to its own package

* Thu Sep 9 1999 Mike Wangsmo <wanger@redhat.com>
- added the documents package

* Wed Sep 8 1999 Mike Wangsmo <wanger@redhat.com>
- added a few more files to the file list
- relocated some things.
- put in a stub config file

* Tue Sep 7 1999 Mike Wangsmo <wanger@redhat.com>
- restructured the package to come from CVS
- renamed it
- added oot's lvs daemon
- added the perl client_monitor tool from Lars Marowsky-Bree
- put stubs in for the GUI
- buffed up the Makefile

* Sun Jul 25 1999 Mike Wangsmo <wanger@redhat.com>
- initial build
